TARGET = task
NAMESRC = task06
CURDIR = $(shell pwd)
FONTS=font1 font2 font3
TESTS=all clean load buffinfo messages show unload format lcd add_user tree
COLOR=text_color text_color


BUILD_KERNEL = "/lib/modules/$(shell uname -r)/build"
# BUILD_KERNEL = "/home/yura/basecamp/Linux_Kernel_GL_Basecamp/linux-5.6.12/linux_build"

# 5.4.0-81
EXTRA_CFLAGS += "-DNOTQUEM"
# 5.6.12
# EXTRA_CFLAGS += "-DQUEM"

KERNELDIR := $(BUILD_KERNEL)

obj-m = $(TARGET).o
$(TARGET)-objs := $(NAMESRC).o lcd_mod.o fonts.o

.PHONY: $(TESTS) $(FONTS) $(COLOR)

all:
	$(MAKE) -C $(KERNELDIR) M=$(CURDIR) modules

clean:
	$(MAKE) -C $(KERNELDIR) M=$(CURDIR) clean


load:
	@sudo dmesg -C
	@echo "Load module:"
	sudo insmod $(TARGET).ko buffer_size=256
# 	sudo insmod $(TARGET).ko

unload:
	@echo "Unload module:"
	sudo rmmod $(TARGET).ko
	@echo ""
	@dmesg

messages:
	@echo ""
	@echo "Add message in buffer:"
	echo "message" | sudo tee /dev/msg01
	echo "message and other word" | sudo tee /dev/msg01
	echo "message and other word and numbers: 0123456789" | sudo tee /dev/msg01
	echo "message and numbers: 0123456789 and chars: abcdefghijklmnopqrstuvwxyz" | sudo tee /dev/msg01
	echo "" | sudo tee /dev/msg01
	@echo ""

show:
	@echo ""
	@echo "Messages in buffer:"
	@sudo cat /dev/msg01
	@echo ""

add_user:
	@echo ""
	@echo "Messages in buffer:"
	echo "User" | sudo tee /sys/class/task06/user
	@echo ""

buffinfo:
	@echo ""
	@echo "Info from buffer:"
	cat /proc/task06/buffer_info
	@echo ""

font1:
	@echo ""
	@echo "Set font Font_7x10"
	@echo "0" | sudo tee /sys/class/task06/font
	@echo ""

font2:
	@echo ""
	@echo "Set font Font_11x18"
	@echo "1" | sudo tee /sys/class/task06/font
	@echo ""

font3:
	@echo ""
	@echo "Set font Font_16x26"
	@echo "2" | sudo tee /sys/class/task06/font
	@echo ""

text_color:
	@echo ""
	@echo "Set text color"
	@echo "255, 0, 255" | sudo tee /sys/class/task06/text_color
	@echo ""

bg_color:
	@echo ""
	@echo "Set background color"
	@echo "255, 255, 255" | sudo tee /sys/class/task06/bg_color
	@echo ""

tree:
	dtc spidev_off.dts -O dtb >spidev_off.dtbo
	sudo dtoverlay -d . spidev_off

test1: load add_user messages show buffinfo unload
test2: load add_user messages show font3 bg_color buffinfo unload
test3: load add_user messages show font3 text_color buffinfo unload


# format:
# 	clang-format -i ./src/*

